package jmvanel.popup.actions;

import java.io.IOException;
import java.util.Iterator;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.eclipse.core.resources.IResource;
import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.IActionDelegate;
import org.eclipse.ui.IObjectActionDelegate;
import org.eclipse.ui.IWorkbenchPart;

public class ActionFile implements IObjectActionDelegate {
    private static final Log log = LogFactory.getLog("net.sourceforge.pmd.eclipse.actions.PMDCheckAction");
	private IWorkbenchPart targetPart;
	ShellCommand projectShellCommand = new ShellCommand();

	/**
	 * Constructor for Action1.
	 */
	public ActionFile() {
		super();
	}

	/**
	 * @see IObjectActionDelegate#setActivePart(IAction, IWorkbenchPart)
	 */
	public void setActivePart(IAction action, IWorkbenchPart targetPart) {
        this.targetPart = targetPart;
	}

	/**
	 * @see IActionDelegate#run(IAction)
	 */
	public void run(IAction action) {
		ISelection sel = targetPart.getSite().getSelectionProvider()
				.getSelection();
		if (sel instanceof IStructuredSelection) {
			IStructuredSelection structuredSel = (IStructuredSelection) sel;
			log.debug("Monitor beginTask(" + structuredSel + ")");
			String actionComment = "";

			for (Iterator i = structuredSel.iterator(); i.hasNext();) {
				Object element = i.next();

				if (element instanceof IAdaptable) {
					IAdaptable adaptable = (IAdaptable) element;
					IResource resource = (IResource) adaptable
							.getAdapter(IResource.class);
					if (resource != null) {
						try {
							String absoluteFileName = resource.getLocation()
									.toOSString();
							projectShellCommand.execute( absoluteFileName +
									" " + resource.getProject().getLocation() );
							actionComment += "FileName: " + absoluteFileName
									+ "\n";
						} catch (IOException e) {
							e.printStackTrace();
							e.printStackTrace();
							actionComment += ", problem executing: "
									+ projectShellCommand + ": " + e;
						}
					} else {
						log.warn("The selected object cannot adapt to a resource");
						log.debug("   -> selected object : " + element);
					}
				} else {
					log.warn("The selected object is not adaptable");
					log.debug("   -> selected object : " + element);
				}
			}
			Shell shell = new Shell();
			MessageDialog.openInformation(shell, "Test_popup Plug-in",
					"New file Action was executed.\n" + actionComment);
		}
	}

	/**
	 * @see IActionDelegate#selectionChanged(IAction, ISelection)
	 */
	public void selectionChanged(IAction action, ISelection selection) {
	}

}
