package jmvanel.popup.actions;

import java.io.File;
import java.io.IOException;

import org.eclipse.core.runtime.Platform;

/** Wrapper for a system command, which is located in the workspace directory.*/
public class ShellCommand {
	/** name of the command file to execute */
	public static final String ACTION_COMMAND = "action";
	
	private String directory;

	ShellCommand() {
		setWorkspaceDirectory(
			Platform.getInstanceLocation().getURL().getFile().toString() );
	}
	
	private void setWorkspaceDirectory(String directory) {
		this.directory = directory;
	}

	public String getWorkspaceDirectory() {
		return directory;
	}
	
	public void execute(String arg) throws IOException {
		String command[] = { this.toString(), arg };
		Runtime.getRuntime().exec(command);
	}

	/** The absolute file name of the command file to execute. @Override */
	public String toString() {
		return directory + File.separator + ACTION_COMMAND;
	}

}
